/********************************** (C) COPYRIGHT *******************************
* File Name          : CH56x_usb30.c
* Author             : WCH
* Version            : V1.1
* Date               : 2020/12/31
* Description 		 :
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.

*******************************************************************************/
#include "MAIN.h"                                                               /* ͷļ */
#include "uvc_conf.h"
#include "USB30_DESC_UVC.h"


/* Global define */
#define SOURCECLOCK             ((~(SysTick->CNT))&0xffffffff)


/* Global Variable */
UINT8V        tx_lmp_port = 0;
UINT8V        link_sta = 0;
UINT8V  lastFrame=0x00;

static UINT32V SetupLen = 0;
static UINT8  SetupReqCode = 0;
static PUINT8 pDescr;

__attribute__((aligned(16))) UINT8 endp0RTbuff[512] __attribute__((section(".DMADATA")));  //˵0շ
__attribute__((aligned(16))) UINT8 endp1RTbuff[4096] __attribute__((section(".DMADATA"))); //˵1շ
__attribute__((aligned(16))) UINT8 endp2RTbuff[4096] __attribute__((section(".DMADATA"))); //˵2շ
__attribute__((aligned(16))) UINT8 endp3RTbuff[4096] __attribute__((section(".DMADATA"))); //˵3շ
__attribute__((aligned(16))) UINT8 endp4RTbuff[4096] __attribute__((section(".DMADATA"))); //˵4շ
__attribute__((aligned(16))) UINT8 endp5RTbuff[4096] __attribute__((section(".DMADATA"))); //˵5շ
__attribute__((aligned(16))) UINT8 endp6RTbuff[4096] __attribute__((section(".DMADATA"))); //˵6շ
__attribute__((aligned(16))) UINT8 endp7RTbuff[4096] __attribute__((section(".DMADATA"))); //˵7շ



UINT32V Endp1_Up_LastPackNum = 0x00;                                            /* ˵1ϴİ */
UINT32V Endp1_Up_LastPackLen = 0x00;                                            /* ˵1ϴİ */
UINT32V Endp1_Up_Status = 0x00;                                                 /* ˵1ϴ״̬: 0: ; 1: ϴ; */
UINT32V Endp1_Down_LastPackNum = 0x00;                                          /* ˵1´İ */
UINT32V Endp1_Down_LastPackLen = 0x00;                                          /* ˵1´İ */
UINT32V Endp1_Down_Status = 0x00;                                               /* ˵1´״̬: 0: ´; 1: ֹͣ´; */
UINT32V Endp1_Down_IdleCount = 0x00;

UINT8V  USB_Down_StopFlag = 0x00;                                               /* USB´ͣ־(USBյ,ȴHSPIټ´) */
UINT8V  HSPI_RX_StopFlag = 0x00;                                                /* HSPIͣ־(HSPIյ,ȴUSBϴټ) */

/* UVCģʽر */
//#if( DEF_USB_MODE_UVC == 0x01 )
volatile MJPEG_HEADER MJPEG_Header;                                             /* UVC֡ͷṹ */
volatile UVC_BUF_INFO UVC_BufInfo;                                              /* UVCϢؽṹ */

UINT32V UVC_ITP_Flag = 0x00;                                                    /* UVCÿ֡ʼ־ */
UINT32V UVC_MBuf_PackCount = 0x00;                                              /* UVC΢ */
UINT32V UVC_MFrame_TimeCount = 0x00;                                            /* UVC΢֡ */
UINT32V UVC_MFrame_PackCount = 0x00;                                            /* UVC΢֡ݰ */
UINT32V UVC_MFrame_PackTotalNum = 0x00;                                         /* UVCǰ΢֡ܰ */
UINT32V UVC_MFrame_LastPackLen = 0x00;                                          /* UVCǰ΢֡ĩβ */
UINT32V UVC_MFrame_ValidFlag = 0x00;                                            /* UVC΢֡Ч־(0:Ч; 1Ч;) */

UINT32V UVC_USBDMA_Addr[ 6 ] =
{
    DEF_ENDP1_TX_DMA_ADDR + ( 0 * 3840*10 ),
    DEF_ENDP1_TX_DMA_ADDR + ( 1 * 3840*10 ),
};

UINT16V Test_Buf[ 2048 ];
UINT32V Test_Offset = 0x00;

// ===== String Descriptor Lang ID=====
// ====================================//

const UINT8 StringLangID[] =
    {
        0x04, // this descriptor length
        0x03, // descriptor type
        0x09, // Language ID 0 low byte
        0x04  // Language ID 0 high byte
};

// ====================================
// =====   String Descriptor 1    =====
// ====================================
const UINT8 StringVendor[] =
    {
        0x08, // length of this descriptor
        0x03,
        'W',
        0x00,
        'C',
        0x00,
        'H',
        0x00};

// ====================================
// =====   String Descriptor 2    =====
// ====================================
const UINT8 StringProduct[] =
    {
        38,         //ĳΪ38ֽ
        0x03,       //ַͱΪ0x03
        0x57, 0x00, //W
        0x43, 0x00, //C
        0x48, 0x00, //H
        0x20, 0x00, //
        0x55, 0x00, //U
        0x53, 0x00, //S
        0x42, 0x00, //B
        0x33, 0x00, //3
        0x2e, 0x00, //.
        0x30, 0x00, //0
        0x20, 0x00, //
        0x44, 0x00, //D
        0x45, 0x00, //E
        0x56, 0x00, //V
        0x49, 0x00, //I
        0x43, 0x00, //C
        0x45, 0x00, //E
        0x20, 0x00};

// ====================================
// =====   String Descriptor 3    =====
// ====================================
UINT8 StringSerial[] =
    {
        0x16, // length of this descriptor
        0x03,
        '0',
        0x00,
        '1',
        0x00,
        '2',
        0x00,
        '3',
        0x00,
        '4',
        0x00,
        '5',
        0x00,
        '6',
        0x00,
        '7',
        0x00,
        '8',
        0x00,
        '9',
        0x00,
};

const UINT8 OSStringDescriptor[] =
    {
        0x12, // length of this descriptor
        0x03,
        'M',
        0x00,
        'S',
        0x00,
        'F',
        0x00,
        'T',
        0x00,
        '1',
        0x00,
        '0',
        0x00,
        '0',
        0x00,
        0x01,
        0x00
    };
//
/* USB3.0 BOS(豸) */
const UINT8 USB30_BOS_Desc[ ] =
{
    0x05,                                                                       /* length of this descriptor */
    0x0f,                                                                       /* CONFIGURATION (2) */
    0x16,                                                                       /* total length includes endpoint descriptors (should be 1 more than last address) */
    0x00,                                                                       /* total length high byte */
    0x02,                                                                       /* number of device cap */

    /*dev_cap_descriptor1 */
    0x07,
    0x10,                                                                       /* DEVICE CAPABILITY type */
    0x02,                                                                       /* USB2.0 EXTENSION */
    0x06,
    0x00,
    0x00,
    0x00,

    /* dev_cap_descriptor2 */
    0x0a,                                                                       /* length of this descriptor */
    0x10,                                                                       /* DEVICE CAPABILITY type */
    0x03,                                                                       /* superspeed usb device capability */
    0x00,
    0x0e,                                                                       /* ss/hs/fs */
    0x00,
    0x01,                                                                       /* the lowest speed is full speed */
    0x0a,                                                                       /* u1 exit latency is 10us */
    0xff,                                                                       /* u1 exit latency is 8us */
    0x07
};



const UINT8 PropertyHeader[] =
    {
        0x8e, 0x00, 0x00, 0x00, 0x00, 01, 05, 00, 01, 00,
        0x84, 0x00, 0x00, 0x00,
        0x01, 0x00, 0x00, 0x00,
        0x28, 0x00,
        0x44, 0x00, 0x65, 0x00, 0x76, 0x00, 0x69, 0x00, 0x63, 0x00, 0x65, 0x00, 0x49, 0x00, 0x6e,
        0x00, 0x74, 0x00, 0x65, 0x00, 0x72, 0x00, 0x66, 0x00, 0x61, 0x00, 0x63, 0x00, 0x65, 0x00, 0x47, 0x00, 0x55, 0x00, 0x49, 0x00, 0x44, 0x00, 0x00, 0x00,

        0x4e, 0x00, 0x00, 0x00,
        0x7b, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00, 0x35, 0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00,
        0x2d, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00,
        0x2d, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00,
        0x2d, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00, 0x2d, 0x00, 0x31, 0x00, 0x32, 0x00, 0x33, 0x00,
        0x34, 0x00, 0x35, 0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00, 0x39, 0x00, 0x41, 0x00, 0x42, 0x00, 0x43, 0x00,
        0x7d, 0x00, 0x00, 0x00};

const UINT8 CompactId[] =
    {
        0x28, 0x00, 0x00, 0x00, 0x00, 0x01, 0x04, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
        0x57, 0x49, 0x4e, 0x55, 0x53, 0x42, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
    };

UINT8 GetStatus[] =
    {
        0x01, 0x00
    };

/*******************************************************************************
 * @fn      USB30_BUS_RESET
 *
 * @brief   USB3.0߸λѡλʽֻλUSBķʽ⣬ԲøλƬķʽ
 *
 * @return   None
 */
void USB30_BUS_RESET()
{
    USB30D_init(DISABLE); //USB3.0ʼ
    mDelaymS(20);
    USB30D_init(ENABLE); //USB3.0ʼ
}

/*******************************************************************************
 * @fn      USB30D_init
 *
 * @brief   USB3.0豸ʼ
 *
 * @return   None
 */
void USB30D_init(FunctionalState sta)
{
    UINT16 i, s;
    if(sta)
    {
        s = USB30_Device_Init();
        if(s)
        {
            printf("Init err\n");
            while(1)
                ;
        }
        USBSS->UEP_CFG = EP0_R_EN | EP0_T_EN | EP1_T_EN | EP3_T_EN ; /* set end point rx/tx enable */
        USB30_ISO_Setendp( 0x81 , ENABLE);
        USBSS->UEP0_DMA = (UINT32)endp0buff;
        USBSS->UEP1_TX_DMA = (UINT32)endp1Tbuff0;
        USBSS->UEP3_TX_DMA = (UINT32)endp3Tbuff;

    }
    else
    {
        USB30_Switch_Powermode(POWER_MODE_2);
        USBSS->LINK_CFG = PIPE_RESET | LFPS_RX_PD;
        USBSS->LINK_CTRL = GO_DISABLED | POWER_MODE_3;
        USBSS->LINK_INT_CTRL = 0;
        USB30_Device_forceclr();
    }
}

/*******************************************************************************
* Function Name  : UVC_SourceClock
* Description    : UVCԴʱ/ر
* Input          : sta     enable/disable
* Output         : None
* Return         : None
*******************************************************************************/
void UVC_SourceClock(FunctionalState sta)
{
    /*systickʱƵʲϵͳƵ ʱԴƵ class-specific VC Interface Descriptorϱ-----------Ҫ*/
  if(sta)
  {
   SysTick->CMP=0xffffffff;
   SysTick->CTLR=(1<<8)|(1<<2)|(1<<0);

  }
  else
  {
      /*systickر*/
      SysTick->CTLR=0;
  }
}
/*******************************************************************************
* Function Name  : UVC_Camera_Ctrl
* Description    : UVCͷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UVC_Camera_Ctrl( void )
{
     UINT32 i,j;
     UINT32 totallen;
     UINT8  offset;
     UINT32 addr;
     UINT32 time;

     if( UsbSetupBuf->wValueL > 0 )
     {
         /* ͷ */
         UVC_MFrame_TimeCount = 0x01;
         UVC_SourceClock(ENABLE);         /* ʱԴ */
         /* ֡ͷ */
         MJPEG_Header.Len = 0x0C;
         MJPEG_Header.Tog = 0x8C;
         MJPEG_Header.timeStamp = ~((*(UINT32V *)(0xe000f004)));//
         MJPEG_Header.sourceClock = 0;
         MJPEG_Header.sofCounts = 0;

         /* ر */
         UVC_MFrame_PackTotalNum = DEF_UVC_BURST_MAX * 3;
         UVC_MFrame_PackCount = UVC_MFrame_PackTotalNum;
         UVC_MBuf_PackCount = 0x00;

         USB30_ITP_Enable(ENABLE);
     }
     else
     {
         /* رͷ */
         USB30_ITP_Enable(DISABLE);
         USB30_IN_ClearIT(1);
         UVC_SourceClock(DISABLE);
         UVC_BufInfo.DealNum=0;
     }

 }

/*******************************************************************************
 * @fn      USB30_NonStandardReq
 *
 * @brief   USB3.0Ǳ׼
 *
 * @return   
 */
UINT16 USB30_NonStandardReq()
{
    UINT8 endp_dir;
    UINT16 len = 0;

    SetupReqCode = UsbSetupBuf->bRequest;
    SetupLen = UsbSetupBuf->wLength;
    endp_dir = UsbSetupBuf->bRequestType & 0x80;

#if 0
    printf("NS:%02x %02x %02x %02x %02x %02x %02x %02x\n", endp0RTbuff[0], endp0RTbuff[1],
            endp0RTbuff[2], endp0RTbuff[3], endp0RTbuff[4], endp0RTbuff[5],
            endp0RTbuff[6], endp0RTbuff[7]);
#endif


    /* ͬģʽ */
    if( endp_dir ){
        if( UsbSetupBuf->bRequestType == 0xA1 )
        {
            switch( UsbSetupBuf->wIndexH )
            {
                case 00:
                    switch(UsbSetupBuf->wIndexL)
                    {
                        case 00:
                            /* Only send request to the VideoControl interface (interface ID 00) */
                            switch( UsbSetupBuf->bRequest )
                            {
                                case 0x81:
                                    /* GET CUR */
                                    pDescr = (PUINT8)&VAICSID[ UsbSetupBuf->wValueH ].cur;
                                    len=10;
                                    break;
                            }
                            break;

                        case 01:
                            switch( UsbSetupBuf->bRequest )
                            {
                                case 0x81:
                                    /* GET CUR */
                                case 0x82:
                                case 0x83:
                                    pDescr = (PUINT8)&UVC_Get_Cur;
                                    len = sizeof(UVC_Get_Cur);
                                    break;
                            }
                            break;
                    }
                    break;

                case 01:
                    switch( UsbSetupBuf->bRequest )
                    {
                        /* LEN->INFO->MIN->MAX->RES->DEF */
                        case 0x81:
                            /* GET CUR */
                            pDescr = (PUINT8)&CameraID[ UsbSetupBuf->wValueH ].cur;
                            len=10;
                            break;

                        case 0x82:
                            /* GET MIN */
                            pDescr = (PUINT8)&CameraID[ UsbSetupBuf->wValueH ].min;
                            break;

                        case 0x83:
                            /* GET MAX */
                            pDescr = (PUINT8)&CameraID[ UsbSetupBuf->wValueH ].max;
                            break;

                        case 0x84:
                            /* GET RES */
                            pDescr = (PUINT8)&CameraID[ UsbSetupBuf->wValueH ].res;
                            break;

                        case 0x85:
                            /* GET LEN */
                            pDescr = (PUINT8)&CameraID[ UsbSetupBuf->wValueH ].len;
                            break;

                        case 0x86:
                            /* GET INFO */
                            pDescr = (PUINT8)&CameraID[ UsbSetupBuf->wValueH ].info;
                            break;

                        case 0x87:
                            /* GET DEF */
                            pDescr = (PUINT8)&CameraID[ UsbSetupBuf->wValueH ].def;
                            break;
                    }
                    break;

                case 02:
                    switch(UsbSetupBuf->bRequest)
                    {
                        /* LEN->INFO->MIN->MAX->RES->DEF */
                        case 0x81:
                            /* GET CUR */
                            pDescr = (PUINT8)&ProcessID[ UsbSetupBuf->wValueH ].cur;
                            break;

                        case 0x82:
                            /* GET MIN */
                            pDescr = (PUINT8)&ProcessID[ UsbSetupBuf->wValueH ].min;
                            break;

                        case 0x83:
                            /* GET MAX */
                            pDescr = (PUINT8)&ProcessID[ UsbSetupBuf->wValueH ].max;
                            break;

                        case 0x84:
                            /* GET RES */
                            pDescr = (PUINT8)&ProcessID[ UsbSetupBuf->wValueH ].res;
                            break;

                        case 0x85:
                            /* GET LEN */
                            pDescr = (PUINT8)&ProcessID[ UsbSetupBuf->wValueH ].len;
                            break;

                        case 0x86:
                            /* GET INFO */
                            pDescr = (PUINT8)&ProcessID[ UsbSetupBuf->wValueH ].info;
                            break;

                        case 0x87:
                            /* GET DEF */
                            pDescr = (PUINT8)&ProcessID[ UsbSetupBuf->wValueH ].def;
                            break;
                    }
                    break;

                case 04:
                    switch( UsbSetupBuf->bRequest )
                    {
                        /* LEN->INFO->MIN->MAX->RES->DEF */
                        case 0x81:
                            /* GET CUR */
                            pDescr = (PUINT8)&ExtensionID1[ UsbSetupBuf->wValueH ].cur;
                            break;

                        case 0x82:
                            /* GET MIN */
                            pDescr = (PUINT8)&ExtensionID1[ UsbSetupBuf->wValueH ].min;
                            break;

                        case 0x83:
                            /* GET MAX */
                            pDescr = (PUINT8)&ExtensionID1[ UsbSetupBuf->wValueH ].max;
                            break;

                        case 0x84:
                            /* GET RES */
                            pDescr = (PUINT8)&ExtensionID1[ UsbSetupBuf->wValueH ].res;
                            break;

                        case 0x85:
                            /* GET LEN */
                            printf("aa\n");
                            pDescr = (PUINT8)&ExtensionID1[ UsbSetupBuf->wValueH ].len;
                            break;

                        case 0x86:
                            /* GET INFO */
                            pDescr = (PUINT8)&ExtensionID1[ UsbSetupBuf->wValueH ].info;
                            break;

                        case 0x87:
                            /* GET DEF */
                            pDescr = (PUINT8)&ExtensionID1[ UsbSetupBuf->wValueH ].def;
                            break;

                    }
                    break;

                case 06:
                    switch(UsbSetupBuf->bRequest)
                    {
                        /* LEN->INFO->MIN->MAX->RES->DEF */
                        case 0x81:
                            /* GET CUR */
                            pDescr = (PUINT8)&ExtensionID2[ UsbSetupBuf->wValueH ].cur;
                            break;

                        case 0x82:
                            /* GET MIN */
                            pDescr = (PUINT8)&ExtensionID2[ UsbSetupBuf->wValueH ].min;
                            break;

                        case 0x83:
                            /* GET MAX */
                            pDescr = (PUINT8)&ExtensionID2[ UsbSetupBuf->wValueH ].max;
                            break;

                        case 0x84:
                            /* GET RES */
                            pDescr = (PUINT8)&ExtensionID2[ UsbSetupBuf->wValueH ].res;
                            break;

                        case 0x85:
                            /* GET LEN */
                            pDescr = (PUINT8)&ExtensionID2[ UsbSetupBuf->wValueH ].len;
                            break;

                        case 0x86:
                            /* GET INFO */
                            pDescr = (PUINT8)&ExtensionID2[ UsbSetupBuf->wValueH ].info;
                            break;

                        case 0x87:
                            /* GET DEF */
                            pDescr = (PUINT8)&ExtensionID2[ UsbSetupBuf->wValueH ].def;
                            break;
                    }
                    break;
            }

            if( UsbSetupBuf->wIndexH == 0x01 && ( ( UsbSetupBuf->wValueH == 0x14 ) || ( UsbSetupBuf->wValueH==0x09 ) ) )
            {
                VAICSID[ 2 ].cur[ 0 ] = (UINT8)DEF_INVALID_CONTROL;
                len = ( 0xFFFF );
            }
        }
    }
    else{
        /* ´ */
          if( ( UsbSetupBuf->bRequestType ) == 0x21 && ( UsbSetupBuf->bRequest == 0x01 ) )
          {
              /* set curͷ */
              return(0);
          }
          if( ( UsbSetupBuf->bRequestType ) == 0xC0 && ( UsbSetupBuf->bRequest == 0x01 ) )
            {
              printf("unsupport winusb/n");
              return( 0XFFFF);//winusb ֧
            }
    }

    len = SetupLen >= ENDP0_MAXPACK ? ENDP0_MAXPACK : SetupLen; // δ䳤
    if(endp_dir)
    {
        memcpy(endp0RTbuff, pDescr, len); // device  /* ϴ */
        pDescr += len;
    }
    SetupLen -= len;
    return len;
}

/*******************************************************************************
 * @fn      USB30_StandardReq
 *
 * @brief   USB3.0׼
 *
 * @return   
 */
UINT16 USB30_StandardReq()
{
    UINT16 len = 0;

    SetupReqCode = UsbSetupBuf->bRequest;
    SetupLen = UsbSetupBuf->wLength;

#if 1
    printf("S:%02x %02x %02x %02x %02x %02x %02x %02x\n", endp0RTbuff[0], endp0RTbuff[1],
            endp0RTbuff[2], endp0RTbuff[3], endp0RTbuff[4], endp0RTbuff[5],
            endp0RTbuff[6], endp0RTbuff[7]);
#endif
    if (( UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK) != USB_REQ_TYP_STANDARD)
    {
        printf("N\n");
       len= USB30_NonStandardReq();
    }
    else{
        switch(SetupReqCode)
        {
            case USB_GET_DESCRIPTOR:
                switch(UsbSetupBuf->wValueH)
                {
                    case USB_DESCR_TYP_DEVICE:
                        SetupLen = 18;
                        pDescr = (PUINT8)USB30_Device_Desc_UVC;
                        break;
                    case USB_DESCR_TYP_CONFIG:
                        if( SetupLen > sizeof( USB30_Config_Desc_UVC ) )
                        {
                            SetupLen = sizeof( USB30_Config_Desc_UVC );
                        }
                        pDescr = (PUINT8)USB30_Config_Desc_UVC;
                        break;
                    case USB_DESCR_TYP_BOS:
                        if( SetupLen > sizeof( USB30_BOS_Desc  ) )
                        {
                            SetupLen = sizeof( USB30_BOS_Desc );
                        }
                        pDescr = (PUINT8)USB30_BOS_Desc;
                        break;
                    case USB_DESCR_TYP_STRING:
                        switch(UsbSetupBuf->wValueL)
                        {
                            case USB_DESCR_LANGID_STRING:
                                if(SetupLen > SIZE_STRING_LANGID)
                                    SetupLen = SIZE_STRING_LANGID;
                                pDescr = (PUINT8)StringLangID;
                                break;
                            case USB_DESCR_VENDOR_STRING:
                                if(SetupLen > SIZE_STRING_VENDOR)
                                    SetupLen = SIZE_STRING_VENDOR;
                                pDescr = (PUINT8)StringVendor;
                                break;
                            case USB_DESCR_PRODUCT_STRING:
                                if(SetupLen > SIZE_STRING_PRODUCT)
                                    SetupLen = SIZE_STRING_PRODUCT;
                                pDescr = (PUINT8)StringProduct;
                                break;
                            case USB_DESCR_SERIAL_STRING:
                                if(SetupLen > SIZE_STRING_SERIAL)
                                    SetupLen = SIZE_STRING_SERIAL;
                                pDescr = (PUINT8)StringSerial;
                                break;
                            case USB_DESCR_OS_STRING:
                                if(SetupLen > SIZE_STRING_OS)
                                    SetupLen = SIZE_STRING_OS;
                                pDescr = (PUINT8)OSStringDescriptor;
                                break;
                            default:
                                len = USB_DESCR_UNSUPPORTED;     //ֵ֧
                                SetupReqCode = INVALID_REQ_CODE; //Ч
                                break;
                        }
                        break;
                    default:
                        len = USB_DESCR_UNSUPPORTED; //ֵ֧
                        SetupReqCode = INVALID_REQ_CODE;
                        break;
                }
                len = SetupLen >= ENDP0_MAXPACK ? ENDP0_MAXPACK : SetupLen; //δ䳤
                memcpy(endp0RTbuff, pDescr, len);                           // device  /*ϴ */
                SetupLen -= len;
                pDescr += len;
                break;
            case USB_SET_ADDRESS:
                SetupLen = UsbSetupBuf->wValueL; // ݴUSB豸ַ
                break;
            case 0x31:
                SetupLen = UsbSetupBuf->wValueL; // ݴUSB豸ַ
                break;
            case 0x30:
                break;
            case USB_SET_CONFIGURATION:
                break;
            case USB_GET_STATUS:
                len = 2;
                endp0RTbuff[0] = 0x01;
                endp0RTbuff[1] = 0x00;
//                SetupLen = 0;
                break;
            case USB_CLEAR_FEATURE:
                break;
            case USB_SET_FEATURE:
                if(UsbSetupBuf->wValueL == 0x30){   //U1
                    printf("enable U1\n");
                    USBSS->LINK_CFG |= (1<<16);
                }
                else if(UsbSetupBuf->wValueL == 0x31){   //U2
                    printf("enable U2\n");
                    USBSS->LINK_CFG |= (1<<17);
                }
                break;
            case USB_SET_INTERFACE:
                printf("set interface:");
                UVC_Camera_Ctrl( );
                len=0;
                break;
            default:
                len = USB_DESCR_UNSUPPORTED; //stallֵ֧
                SetupReqCode = INVALID_REQ_CODE;
                printf("stall \n");
                break;
        }
}
    return len;
}

/*******************************************************************************
 * @fn      EP0_IN_Callback
 *
 * @brief   USB3.0˵0INص
 *
 * @return   ͳ
 */
UINT16 EP0_IN_Callback(void)
{
    UINT16 len = 0;
    switch(SetupReqCode)
    {
        case USB_GET_DESCRIPTOR:
            len = SetupLen >= ENDP0_MAXPACK ? ENDP0_MAXPACK : SetupLen;
            memcpy(endp0RTbuff, pDescr, len);
            SetupLen -= len;
            pDescr += len;
            break;
    }
    return len;
}

/*******************************************************************************
 * @fn      EP0_OUT_Callback
 *
 * @brief   USB3.0˵0OUTص
 *
 * @return   
 */
UINT16 EP0_OUT_Callback(void)
{
    UINT16 len=0;
    return len;
}

/*******************************************************************************
 * @fn      USB30_Setup_Status
 *
 * @brief   USB3.0ƴ״̬׶λص
 *
 * @return   None
 */
void USB30_Setup_Status(void)
{
    switch(SetupReqCode)
    {
        case USB_SET_ADDRESS:
            USB30_Device_Setaddress(SetupLen); // SET ADDRESS
            break;
        case 0x81:
            VAICSID[ UsbSetupBuf->wValueH ].cur[ 0 ] = DEF_NO_ERROR;
             break;
        case 0x31:
            USB30_ISO_Setdelay( SetupLen );
            break;
    }
}

/*******************************************************************************
 * @fn      USBSS_IRQHandler
 *
 * @brief   USB3.0 Interrupt Handler.
 *
 * @return   None
 */
void USBSS_IRQHandler(void) //USBSS interrupt service
{
    USB30_IRQHandler();
}

/*******************************************************************************
 * @fn      TMR0_IRQHandler
 *
 * @brief   USB3.0ʧܳʱ
 *
 * @return   None
 */
void TMR0_IRQHandler()
{
    R8_TMR0_INT_FLAG = RB_TMR_IF_CYC_END;

    if(link_sta == 1)
    {
        link_sta = 0;
        PFIC_DisableIRQ(USBSS_IRQn);
        PFIC_DisableIRQ(LINK_IRQn);
        USB30D_init(DISABLE);
        PRINT("USB3.0 disable\n");
        return;
    }
    if(link_sta != 3)
    {
        PFIC_DisableIRQ(USBSS_IRQn);
        PFIC_DisableIRQ(LINK_IRQn);
        USB30D_init(DISABLE);
        //        PRINT("USB2.0\n");
        R32_USB_CONTROL = 0;
        PFIC_EnableIRQ(USBHS_IRQn);
        USB20_Device_Init(ENABLE);
    }
    link_sta = 1;
    R8_TMR0_INTER_EN = 0;
    PFIC_DisableIRQ(TMR0_IRQn);
    R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
}

/*******************************************************************************
 * @fn      LINK_IRQHandler
 *
 * @brief   USB3.0 Link Interrupt Handler.
 *
 * @return   None
 */
void LINK_IRQHandler() //USBSS link interrupt service
{
    if(USBSS->LINK_INT_FLAG & LINK_Ux_EXIT_FLAG) // device enter U2
    {
        USBSS->LINK_CFG = CFG_EQ_EN | DEEMPH_CFG | TERM_EN;
        USB30_Switch_Powermode(POWER_MODE_0);
        USBSS->LINK_INT_FLAG = LINK_Ux_EXIT_FLAG;
    }

    if(USBSS->LINK_INT_FLAG & LINK_RDY_FLAG) // POLLING SHAKE DONE
    {
        USBSS->LINK_INT_FLAG = LINK_RDY_FLAG;
        if(tx_lmp_port) // LMP, TX PORT_CAP & RX PORT_CAP
        {
            USBSS->LMP_TX_DATA0 = LINK_SPEED | PORT_CAP | LMP_HP;
            USBSS->LMP_TX_DATA1 = UP_STREAM | NUM_HP_BUF;
            USBSS->LMP_TX_DATA2 = 0x0;
            tx_lmp_port = 0;
        }
        //ɹUSB3.0ͨѶ
        link_sta = 3;
        PFIC_DisableIRQ(TMR0_IRQn);
        R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
        R8_TMR0_INTER_EN = 0;
        PFIC_DisableIRQ(USBHS_IRQn);
        USB20_Device_Init(DISABLE);
    }

    if(USBSS->LINK_INT_FLAG & LINK_INACT_FLAG)
    {
        USBSS->LINK_INT_FLAG = LINK_INACT_FLAG;
        USB30_Switch_Powermode(POWER_MODE_2);
    }

    if(USBSS->LINK_INT_FLAG & LINK_DISABLE_FLAG) // GO DISABLED
    {
        USBSS->LINK_INT_FLAG = LINK_DISABLE_FLAG;
        link_sta = 1;
        USB30D_init(DISABLE);
        PFIC_DisableIRQ(USBSS_IRQn);
        R8_TMR0_CTRL_MOD = RB_TMR_ALL_CLEAR;
        R8_TMR0_INTER_EN = 0;
        PFIC_DisableIRQ(TMR0_IRQn);
        PFIC_EnableIRQ(USBHS_IRQn);
        USB20_Device_Init(ENABLE);
    }

    if(USBSS->LINK_INT_FLAG & LINK_RX_DET_FLAG)
    {
        USBSS->LINK_INT_FLAG = LINK_RX_DET_FLAG;
        USB30_Switch_Powermode(POWER_MODE_2);
    }

    if(USBSS->LINK_INT_FLAG & TERM_PRESENT_FLAG) // term present , begin POLLING
    {
        USBSS->LINK_INT_FLAG = TERM_PRESENT_FLAG;
        if(USBSS->LINK_STATUS & LINK_PRESENT)
        {
            USB30_Switch_Powermode(POWER_MODE_2);
            USBSS->LINK_CTRL |= POLLING_EN;
        }
        else
        {
            USBSS->LINK_INT_CTRL = 0;
            mDelayuS(2000);
            USB30_BUS_RESET();
        }
    }

    if(USBSS->LINK_INT_FLAG & LINK_TXEQ_FLAG) // POLLING SHAKE DONE
    {
        tx_lmp_port = 1;
        USBSS->LINK_INT_FLAG = LINK_TXEQ_FLAG;
        USB30_Switch_Powermode(POWER_MODE_0);
    }

    if(USBSS->LINK_INT_FLAG & WARM_RESET_FLAG)
    {
        USBSS->LINK_INT_FLAG = WARM_RESET_FLAG;
        USB30_Switch_Powermode(POWER_MODE_2);
        USB30_BUS_RESET();
        USB30_Device_Setaddress(0);
        USBSS->LINK_CTRL |= TX_WARM_RESET;
        while(USBSS->LINK_STATUS & RX_WARM_RESET)
            ;
        USBSS->LINK_CTRL &= ~TX_WARM_RESET;
        mDelayuS(2);
        //        printf("warm reset\n");
    }

    if(USBSS->LINK_INT_FLAG & HOT_RESET_FLAG) //ܻ·hot reset,ע˵
    {
        USBSS->USB_CONTROL |= 1 << 31;
        USBSS->LINK_INT_FLAG = HOT_RESET_FLAG; // HOT RESET begin
        USB30_IN_ClearIT(0);
        USB30_IN_Set(ENDP_1, DISABLE, NRDY, 0, 0);
        USB30_IN_Set(ENDP_3, DISABLE, NRDY, 0, 0);

        USB30_Device_Setaddress(0);
        USBSS->LINK_CTRL &= ~TX_HOT_RESET; // HOT RESET end
    }

    if(USBSS->LINK_INT_FLAG & LINK_GO_U1_FLAG) // device enter U1
    {
        USB30_Switch_Powermode(POWER_MODE_1);
        USBSS->LINK_INT_FLAG = LINK_GO_U1_FLAG;
    }

    if(USBSS->LINK_INT_FLAG & LINK_GO_U2_FLAG) // device enter U2
    {
        USB30_Switch_Powermode(POWER_MODE_2);
        USBSS->LINK_INT_FLAG = LINK_GO_U2_FLAG;
    }

    if(USBSS->LINK_INT_FLAG & LINK_GO_U3_FLAG) // device enter U2
    {
        USB30_Switch_Powermode(POWER_MODE_2);
        USBSS->LINK_INT_FLAG = LINK_GO_U3_FLAG;
    }
}
/***************Endpointn IN Transaction Processing*******************/
/*******************************************************************************
 * @fn      EP1_IN_Callback
 *
 * @brief   USB3.0 endpoint1 in callback.
 *
 * @return   None
 */
void EP1_IN_Callback(void)
{
    UINT8  nump;
    UINT16 packnum;
//===============================================================================================================================================
    /* ˵1ϴ */
    /* ͬģʽ */
    /* ж */
    USB30_IN_ClearIT(1);

    /* жϵǰϴЧݻЧ */

    nump = USB30_IN_Nump( 1 );

    if( UVC_MFrame_ValidFlag )
    {
        UVC_MFrame_ValidFlag = 0x00;

        /* лUSBַ */
        HSPI_Rx_Data_DealAddr += ( nump * 1024 );
        if( HSPI_Rx_Data_DealAddr >= ( DEF_HPSI_DMA_RX_ADDR0 + 3840*10*2) )    //DEF_ENDP1_TX_BUF_LEN_UVC
        {
            HSPI_Rx_Data_DealAddr = DEF_HPSI_DMA_RX_ADDR0;
        }
        /* 㵱ǰ΢Ƿϴ */
        UVC_MBuf_PackCount += nump;
        if( UVC_MBuf_PackCount >= UVC_MFrame_PackTotalNum )
        {
            UVC_MBuf_PackCount -= UVC_MFrame_PackTotalNum;
            R8_HSPI_INT_EN = 0x00;
            R8_HSPI_INT_EN = 0x00;
            R8_HSPI_INT_EN = 0x00;
            UVC_BufInfo.RemainCount--;
            UVC_BufInfo.DealNum++;
            if( UVC_BufInfo.DealNum >= 2)      // DEF_ENDP1_TX_BUF_LEN_UVC / DEF_HSPI_UVC_BPACK_LEN
            {
                UVC_BufInfo.DealNum = 0x00;
            }
            /* ӻHRTS֪ͨHSPI16K */
            if( HSPI_Rx_Notice_Status == 0x01 )
            {
                HSPI_Rx_Notice_Status = 0x00;
                PIN_HRTS_LOW( );
            }
            R8_HSPI_INT_EN = HSPI_Int_En_Save;
        }

        /* 㵱ǰ΢֡Ƿϴ */
        UVC_MFrame_PackCount += nump;
        if( UVC_MFrame_PackCount < UVC_MFrame_PackTotalNum )
        {
            /* лϴ */
            USBSS->UEP1_TX_DMA = HSPI_Rx_Data_DealAddr;
            packnum = UVC_MFrame_PackTotalNum - UVC_MFrame_PackCount;
            if( packnum >= DEF_UVC_BURST_MAX )
            {
                USB30_IN_ClearIT(1);
                USB30_Set_endp_seqnumber(0x81,&UVC_MFrame_PackCount);
                USB30_IN_Set( 1 , 0 , NRDY , DEF_UVC_BURST_MAX , 1024  );
            }
            else
            {
                USB30_IN_ClearIT(1);
                USB30_Set_endp_seqnumber(0x81,&UVC_MFrame_PackCount);
                USB30_IN_Set( 1 , 1 , NRDY , packnum , UVC_MFrame_LastPackLen  );
            }
            UVC_MFrame_ValidFlag = 0x01;
        }
    }



}
/*******************************************************************************
 * @fn      USB30_ITP_Callback
 *
 * @brief   USB3.0 ITPص
 *
 * @return   None
 */
void USB30_ITP_Callback(UINT32 ITPCounter)
{
    static UINT32V remanlen;

    /* USB3.0 ITP */
    /* жϵηǷΪµһ֡(125uS) */


    UVC_ITP_Flag = 0x01;

    /* ֡ */
   UVC_MFrame_TimeCount++;
    if( UVC_MFrame_TimeCount % 8 == 0 )
    {
       /*֡ msΪλ*/
        MJPEG_Header.sofCounts = ( ++MJPEG_Header.sofCounts ) & 0x07ff;
    }
    /* ǰǰһ΢֡ûȫ,һ΢֡· */

    R8_HSPI_INT_EN = 0x00;
    R8_HSPI_INT_EN = 0x00;
    R8_HSPI_INT_EN = 0x00;
    remanlen = UVC_BufInfo.RemainCount;
    R8_HSPI_INT_EN = HSPI_Int_En_Save;
    if( remanlen )
    {
        UVC_MFrame_PackCount = 0x00;
        UVC_MBuf_PackCount = 0x00;
        UVC_MFrame_ValidFlag = 0x01;
        MJPEG_Header.Tog &= ~(1<<1);
        /* ͼƬ֡ͷֽ */
        if((lastFrame==1))                                             //һ֡ս־һ΢֡12ֽͷ||(MJPEG_Header.Tog & 0x02)||( MJPEG_Header.Tog &(1<<1))
        {
            MJPEG_Header.Tog ^= 0x01;                                  //ͼƬ߽֡01л
            MJPEG_Header.Tog &= ~(1<<1);
            MJPEG_Header.timeStamp = ~((*(UINT32V *)(0xe000f004)));                      //µһ֡ͼƬʼ͵ʱʱŸ
            lastFrame=0;
        }
        /* жϵǰ΢֡Ƿ֡ĩβ */
        if( UVC_BufInfo.FullFlag[ UVC_BufInfo.DealNum ] == 0x00 )
        {
            MJPEG_Header.sourceClock = (UINT32)SOURCECLOCK;                               //ʱԴÿͬ΢֡
            /* 㵱ǰ΢֡ĩβ */
            UVC_MFrame_PackTotalNum = UVC_BufInfo.Length[ UVC_BufInfo.DealNum ] / 1024;
            UVC_MFrame_LastPackLen =  UVC_BufInfo.Length[ UVC_BufInfo.DealNum ] % 1024;
            if( UVC_MFrame_LastPackLen )
            {
                UVC_MFrame_PackTotalNum++;
            }
            else if( UVC_MFrame_LastPackLen == 0 )
            {
                UVC_MFrame_LastPackLen = 1024;
            }
            /* Чݰϴ */
            HSPI_Rx_Data_DealAddr = UVC_USBDMA_Addr[ UVC_BufInfo.DealNum ];
            USBSS->UEP1_TX_DMA = HSPI_Rx_Data_DealAddr;
            memcpy( (UINT8 *)( HSPI_Rx_Data_DealAddr ),  (uint8_t *)&MJPEG_Header, 12 );
            if( UVC_MFrame_PackTotalNum >= DEF_UVC_BURST_MAX )
            {
                USB30_IN_ClearIT(1);
                USB30_Set_endp_seqnumber(0x81,&UVC_MFrame_PackCount);
                USB30_IN_Set(1 , 0 , NRDY , DEF_UVC_BURST_MAX , 1024  );
            }
            else
            {
                USB30_IN_ClearIT(1);
                USB30_Set_endp_seqnumber(0x81,&UVC_MFrame_PackCount);
                USB30_IN_Set( 1 , 1 , NRDY , UVC_MFrame_PackTotalNum , UVC_MFrame_LastPackLen );
            }
        }
        else
        {

            /* ͼƬ֡ͷֽ */
            MJPEG_Header.Tog |= 0x02;                                                     //Ļһ֡ͼƬ һ֡
            lastFrame=1;                                                                  //ͼƬ֡־  ´θʱ
            MJPEG_Header.sourceClock = (UINT32)SOURCECLOCK;                               //ʱԴÿͬ΢֡   ڷ֮ǰȡ֤ϴʱʱ
            /* 㵱ǰ΢֡ĩβ */
            UVC_MFrame_PackTotalNum = UVC_BufInfo.Length[ UVC_BufInfo.DealNum ] / 1024;
            UVC_MFrame_LastPackLen = UVC_BufInfo.Length[ UVC_BufInfo.DealNum ] % 1024;

            if( UVC_MFrame_LastPackLen )
            {
                UVC_MFrame_PackTotalNum++;
            }
            else if( UVC_MFrame_LastPackLen == 0 )
            {
                UVC_MFrame_LastPackLen = 1024;
            }

            /* Чݰϴ */
            HSPI_Rx_Data_DealAddr = UVC_USBDMA_Addr[ UVC_BufInfo.DealNum ];
            USBSS->UEP1_TX_DMA = HSPI_Rx_Data_DealAddr;
            memcpy( (UINT8 *)( HSPI_Rx_Data_DealAddr ),  (uint8_t *)&MJPEG_Header, 12 );
            if( UVC_MFrame_PackTotalNum >= DEF_UVC_BURST_MAX )
            {
                USB30_IN_ClearIT(1);
                USB30_Set_endp_seqnumber(0x81,&UVC_MFrame_PackCount);
                USB30_IN_Set( 1 , 0 , NRDY , DEF_UVC_BURST_MAX , 1024  );
            }
            else
            {
                USB30_IN_ClearIT(1);
                USB30_Set_endp_seqnumber(0x81,&UVC_MFrame_PackCount);
                USB30_IN_Set( 1 , 1 , NRDY , UVC_MFrame_PackTotalNum , UVC_MFrame_LastPackLen  );
            }
        }

    }
    else
    {
        UVC_MFrame_PackCount = 0x00;
        UVC_MBuf_PackCount = 0x00;
        UVC_MFrame_ValidFlag = 0x00;
        MJPEG_Header.timeStamp = 0;                      //ֻ12ֽͷʱ ʱʾ00
        MJPEG_Header.sourceClock = (UINT32)SOURCECLOCK;
        MJPEG_Header.Tog &= ~(1<<1);                     //ͼƬ֡־
        /* Чݰϴ */
        USBSS->UEP1_TX_DMA = HSPI_Rx_Data_DealAddr;
        memcpy( (UINT8 *)( HSPI_Rx_Data_DealAddr ),  (uint8_t *)&MJPEG_Header, 12 );

        USB30_IN_ClearIT(1);
        USB30_Set_endp_seqnumber(0x81,&UVC_MFrame_PackCount);
        USB30_IN_Set(1,1,NRDY,1,0x0C  );

    }
    /* жǷҪ֪ͨHSPI */
    if( remanlen < DEF_UVC_BUF_NUM )
    {
        /* ӻHRTS֪ͨ16K */
        if( HSPI_Rx_Notice_Status == 0x01 )
        {
            HSPI_Rx_Notice_Status = 0x00;
            PIN_HRTS_LOW( );
        }
    }



}
/*******************************************************************************
 * @fn      EP2_IN_Callback
 *
 * @brief   USB3.0 endpoint2 in callback.
 *
 * @return   None
 */
void EP2_IN_Callback(void)
{
//    UINT8 nump;
//    nump = USB30_IN_Nump(ENDP_2); //nump ʣͰ
//    if(nump == 0)
//    {                                                                      //ȫ
//        USBSS->UEP2_TX_DMA = (UINT32)(UINT8 *)endp2RTbuff;                 //ͻ DMAַƫ 
//        USB30_IN_ClearIT(ENDP_2);                                          //˵״̬ к
//        USB30_IN_Set(ENDP_2, ENABLE, ACK, DEF_ENDP2_IN_BURST_LEVEL, 1024); //ö˵ܹ4
//        USB30_Send_ERDY(ENDP_2 | IN, DEF_ENDP2_IN_BURST_LEVEL);            //֪ͨȡ4
//    }
//    else if(nump == 1)
//    {
//        USB30_IN_ClearIT(ENDP_2);                   //˵״̬ к
//        USB30_IN_Set(ENDP_2, ENABLE, ACK, 1, 1024); //ܹ1
//        USB30_Send_ERDY(ENDP_2 | IN, 1);
//    }
//    else if(nump == 2)
//    {
//        USB30_IN_ClearIT(ENDP_2);                   //˵״̬ к
//        USB30_IN_Set(ENDP_2, ENABLE, ACK, 2, 1024); //ܹ2
//        USB30_Send_ERDY(ENDP_2 | IN, 2);
//    }
//    else if(nump == 3)
//    {
//        USB30_IN_ClearIT(ENDP_2);                   //˵״̬ к
//        USB30_IN_Set(ENDP_2, ENABLE, ACK, 3, 1024); //ܹ3
//        USB30_Send_ERDY(ENDP_2 | IN, 3);
//    }
}

/*******************************************************************************
 * @fn      EP3_IN_Callback
 *
 * @brief   USB3.0 endpoint3 in callback.
 *
 * @return   None
 */
void EP3_IN_Callback(void)
{
//    UINT8 nump;
//    nump = USB30_IN_Nump(ENDP_3); //nump ʣͰ
//    if(nump == 0)
//    {
//        USBSS->UEP3_TX_DMA = (UINT32)(UINT8 *)endp3RTbuff;        //ͻ DMAַƫ 
//        USB30_IN_ClearIT(ENDP_3);                                 //˵״̬ к
//        USB30_OUT_Set(ENDP_3, ACK, DEF_ENDP3_OUT_BURST_LEVEL);    //ܹ4
//        USB30_Send_ERDY(ENDP_3 | OUT, DEF_ENDP3_OUT_BURST_LEVEL); //֪ͨ4
//    }
//    else if(nump == 1)
//    {
//        USB30_IN_ClearIT(ENDP_3);                   //˵״̬ к
//        USB30_IN_Set(ENDP_3, ENABLE, ACK, 1, 1024); //ܹ1
//        USB30_Send_ERDY(ENDP_3 | IN, 1);
//    }
//    else if(nump == 2)
//    {
//        USB30_IN_ClearIT(ENDP_3);                   //˵״̬ к
//        USB30_IN_Set(ENDP_3, ENABLE, ACK, 2, 1024); //ܹ2
//        USB30_Send_ERDY(ENDP_3 | IN, 2);
//    }
//    else if(nump == 3)
//    {
//        USB30_IN_ClearIT(ENDP_3);                   //˵״̬ к
//        USB30_IN_Set(ENDP_3, ENABLE, ACK, 3, 1024); //ܹ3
//        USB30_Send_ERDY(ENDP_3 | IN, 3);
//    }
}

/*******************************************************************************
 * @fn      EP4_IN_Callback
 *
 * @brief   USB3.0 endpoint4 in callback.
 *
 * @return   None
 */
void EP4_IN_Callback(void)
{
//    UINT8 nump;
//    nump = USB30_IN_Nump(ENDP_4); //s: ʣͰ
//    if(nump == 0)
//    {                                                             //ȫ
//        USBSS->UEP4_TX_DMA = (UINT32)(UINT8 *)endp4RTbuff;        //ͻ DMAַƫ 
//        USB30_IN_ClearIT(ENDP_4);                                 //˵״̬ к
//        USB30_OUT_Set(ENDP_4, ACK, DEF_ENDP4_OUT_BURST_LEVEL);    //ܹ4
//        USB30_Send_ERDY(ENDP_4 | OUT, DEF_ENDP4_OUT_BURST_LEVEL); //֪ͨ4
//    }
//    else if(nump == 1) //ʣһû
//    {
//        USB30_IN_ClearIT(ENDP_4);                   //˵״̬ к
//        USB30_IN_Set(ENDP_4, ENABLE, ACK, 1, 1024); //ܹ1
//        USB30_Send_ERDY(ENDP_4 | IN, 1);
//    }
//    else if(nump == 2)
//    {
//        USB30_IN_ClearIT(ENDP_4);                   //˵״̬ к
//        USB30_IN_Set(ENDP_4, ENABLE, ACK, 2, 1024); //ܹ2
//        USB30_Send_ERDY(ENDP_4 | IN, 2);
//    }
//    else if(nump == 3)
//    {
//        USB30_IN_ClearIT(ENDP_4);                   //˵״̬ к
//        USB30_IN_Set(ENDP_4, ENABLE, ACK, 3, 1024); //ܹ3
//        USB30_Send_ERDY(ENDP_4 | IN, 3);
//    }
}
/*******************************************************************************
 * @fn      EP5_IN_Callback
 *
 * @brief   USB3.0 endpoint5 in callback.
 *
 * @return   None
 */
void EP5_IN_Callback(void)
{
//    UINT8 nump;
//    nump = USB30_IN_Nump(ENDP_5); //nump ʣͰ
//    if(nump == 0)
//    {                                                             //ȫ
//        USBSS->UEP5_TX_DMA = (UINT32)(UINT8 *)endp5RTbuff;        //ͻ DMAַƫ 
//        USB30_IN_ClearIT(ENDP_5);                                 //˵״̬ к
//        USB30_OUT_Set(ENDP_5, ACK, DEF_ENDP5_OUT_BURST_LEVEL);    //ܹ4
//        USB30_Send_ERDY(ENDP_5 | OUT, DEF_ENDP5_OUT_BURST_LEVEL); //֪ͨ4
//    }
//    else if(nump == 1) //ʣһδ
//    {
//        USB30_IN_ClearIT(ENDP_5);                   //˵״̬ к
//        USB30_IN_Set(ENDP_5, ENABLE, ACK, 1, 1024); //ܹ1
//        USB30_Send_ERDY(ENDP_5 | IN, 1);
//    }
//    else if(nump == 2)
//    {
//        USB30_IN_ClearIT(ENDP_5);                   //˵״̬ к
//        USB30_IN_Set(ENDP_5, ENABLE, ACK, 2, 1024); //ܹ2
//        USB30_Send_ERDY(ENDP_5 | IN, 2);
//    }
//    else if(nump == 3)
//    {
//        USB30_IN_ClearIT(ENDP_5);                   //˵״̬ к
//        USB30_IN_Set(ENDP_5, ENABLE, ACK, 3, 1024); //ܹ3
//        USB30_Send_ERDY(ENDP_5 | IN, 3);
//    }
}
/*******************************************************************************
 * @fn      EP6_IN_Callback
 *
 * @brief   USB3.0 endpoint6 in callback.
 *
 * @return   None
 */
void EP6_IN_Callback(void)
{
//    UINT8 nump;
//    nump = USB30_IN_Nump(ENDP_6); //nump ʣͰ
//    if(nump == 0)
//    {                                                             //ȫ
//        USBSS->UEP6_TX_DMA = (UINT32)(UINT8 *)endp6RTbuff;        //ͻ DMAַƫ 
//        USB30_IN_ClearIT(ENDP_6);                                 //˵״̬ к
//        USB30_OUT_Set(ENDP_6, ACK, DEF_ENDP6_OUT_BURST_LEVEL);    //ܹ4
//        USB30_Send_ERDY(ENDP_6 | OUT, DEF_ENDP6_OUT_BURST_LEVEL); //֪ͨ4
//    }
//    else if(nump == 1) //ʣһû
//    {
//        USB30_IN_ClearIT(ENDP_6);                   //˵״̬ к
//        USB30_IN_Set(ENDP_6, ENABLE, ACK, 1, 1024); //ܹ4
//        USB30_Send_ERDY(ENDP_6 | IN, 1);
//    }
//    else if(nump == 2)
//    {
//        USB30_IN_ClearIT(ENDP_6);                   //˵״̬ к
//        USB30_IN_Set(ENDP_6, ENABLE, ACK, 2, 1024); //ܹ4
//        USB30_Send_ERDY(ENDP_6 | IN, 2);
//    }
//    else if(nump == 3)
//    {
//        USB30_IN_ClearIT(ENDP_6);                   //˵״̬ к
//        USB30_IN_Set(ENDP_6, ENABLE, ACK, 3, 1024); //ܹ4
//        USB30_Send_ERDY(ENDP_6 | IN, 3);
//    }
}
/*******************************************************************************
 * @fn      EP7_IN_Callback
 *
 * @brief   USB3.0 endpoint7 in callback.
 *
 * @return   None
 */
void EP7_IN_Callback(void)
{
//    UINT8 nump;
//    nump = USB30_IN_Nump(ENDP_7); //nump:ʣͰ
//    if(nump == 0)
//    {                                                             //ȫ
//        USBSS->UEP7_TX_DMA = (UINT32)(UINT8 *)endp7RTbuff;        //ͻ DMAַƫ 
//        USB30_IN_ClearIT(ENDP_7);                                 //˵״̬ к
//        USB30_OUT_Set(ENDP_7, ACK, DEF_ENDP7_OUT_BURST_LEVEL);    //ܹ4
//        USB30_Send_ERDY(ENDP_7 | OUT, DEF_ENDP7_OUT_BURST_LEVEL); //֪ͨ4
//    }
//    else if(nump == 1) //ʣһδ
//    {
//        USB30_IN_ClearIT(ENDP_7);                   //˵״̬ к
//        USB30_IN_Set(ENDP_7, ENABLE, ACK, 1, 1024); //ܹ1
//        USB30_Send_ERDY(ENDP_7 | IN, 1);
//    }
//    else if(nump == 2)
//    {
//        USB30_IN_ClearIT(ENDP_7);                   //˵״̬ к
//        USB30_IN_Set(ENDP_7, ENABLE, ACK, 2, 1024); //ܹ2
//        USB30_Send_ERDY(ENDP_7 | IN, 2);
//    }
//    else if(nump == 3)
//    {
//        USB30_IN_ClearIT(ENDP_7);                   //˵״̬ к
//        USB30_IN_Set(ENDP_7, ENABLE, ACK, 3, 1024); //ܹ3
//        USB30_Send_ERDY(ENDP_7 | IN, 3);
//    }
}
/***************Endpointn OUT Transaction Processing*******************/

/*******************************************************************************
 * @fn      EP1_OUT_Callback
 *
 * @brief   USB3.0 endpoint1 out callback.
 *
 * @return   None
 */
void EP1_OUT_Callback(void)
{
//    UINT16 rx_len, i;
//    UINT8  nump;
//    UINT8  status;
//    USB30_OUT_Status(ENDP_1, &nump, &rx_len, &status); //ȡյİ   rxlen Ϊһİ
//    if(nump == 0)
//    {
//        USB30_OUT_ClearIT(ENDP_1);                                         //˵״̬ 
//        USBSS->UEP1_RX_DMA = (UINT32)(UINT8 *)endp1RTbuff;                 //ͻģʽڵַԶƫ ַ
//        USB30_IN_Set(ENDP_1, ENABLE, ACK, DEF_ENDP1_IN_BURST_LEVEL, 1024); //ܹ1Ŷ˵ܷ4
//        USB30_Send_ERDY(ENDP_1 | IN, DEF_ENDP1_IN_BURST_LEVEL);            //֪ͨȡ4
//    }
//    else if(nump == 1) //Խһ
//    {
//        USB30_OUT_ClearIT(ENDP_1);
//        USB30_OUT_Set(ENDP_1, ACK, 1);    //ܹһ
//        USB30_Send_ERDY(ENDP_1 | OUT, 1); //֪ͨ·1
//    }
//    else if(nump == 2)
//    {
//        USB30_OUT_ClearIT(1);
//        USB30_OUT_Set(ENDP_1, ACK, 2);    //ܹ2
//        USB30_Send_ERDY(ENDP_1 | OUT, 2); //֪ͨ·2
//    }
//    else if(nump == 3)
//    {
//        USB30_OUT_ClearIT(1);
//        USB30_OUT_Set(ENDP_1, ACK, 3);    //ܹ3
//        USB30_Send_ERDY(ENDP_1 | OUT, 3); //֪ͨ·3
//    }
}

/*******************************************************************************
 * @fn      EP2_OUT_Callback
 *
 * @brief   USB3.0 endpoint2 out callback.
 *
 * @return   None
 */
void EP2_OUT_Callback(void)
{
//    UINT16 rx_len, i;
//    UINT8  nump;
//    UINT8  status;
//    UINT32 recv_index;
//    USB30_OUT_Status(ENDP_2, &nump, &rx_len, &status); //ȡյİ
//    if(nump == 0)                                      //ȫ
//    {
//        USB30_OUT_ClearIT(ENDP_2);                                //˵״̬ 
//        USBSS->UEP2_RX_DMA = (UINT32)(UINT8 *)endp2RTbuff;        //ͻģʽڵַԶƫ ַ
//        USB30_OUT_Set(ENDP_2, ACK, DEF_ENDP2_OUT_BURST_LEVEL);    //ö˵ܹ4
//        USB30_Send_ERDY(ENDP_2 | OUT, DEF_ENDP2_OUT_BURST_LEVEL); //֪ͨ·4
//    }
//    else if(nump == 1)
//    {
//        USB30_OUT_ClearIT(ENDP_2);
//        USB30_OUT_Set(ENDP_2, ACK, 1);    //ܹһ
//        USB30_Send_ERDY(ENDP_2 | OUT, 1); //֪ͨ·һ
//    }
//    else if(nump == 2)
//    {
//        USB30_OUT_ClearIT(ENDP_2);
//        USB30_OUT_Set(ENDP_2, ACK, 2);    //ܹ2
//        USB30_Send_ERDY(ENDP_2 | OUT, 2); //֪ͨ·2
//    }
//    else if(nump == 3)
//    {
//        USB30_OUT_ClearIT(ENDP_2);
//        USB30_OUT_Set(ENDP_2, ACK, 3);    //ܹ3
//        USB30_Send_ERDY(ENDP_2 | OUT, 3); //֪ͨ·3
//    }
}
/*******************************************************************************
 * @fn      EP3_OUT_Callback
 *
 * @brief   USB3.0 endpoint3 out callback.
 *
 * @return   None
 */
void EP3_OUT_Callback(void)
{
//    UINT16 rx_len, i;
//    UINT8  nump;
//    UINT8  status;
//    USB30_OUT_Status(ENDP_3, &nump, &rx_len, &status); //ȡյİ
//    if(nump == 0)
//    {
//        USB30_OUT_ClearIT(ENDP_3);                                         //˵״̬ 
//        USBSS->UEP3_RX_DMA = (UINT32)(UINT8 *)endp3RTbuff;                 //ͻģʽڵַԶƫ ַ
//        USB30_IN_Set(ENDP_3, ENABLE, ACK, DEF_ENDP3_IN_BURST_LEVEL, 1024); //ܹ4
//        USB30_Send_ERDY(ENDP_3 | IN, DEF_ENDP3_IN_BURST_LEVEL);            //֪ͨȡ4
//    }
//    else if(nump == 1)
//    {
//        USB30_OUT_ClearIT(ENDP_3);
//        USB30_OUT_Set(ENDP_3, ACK, 1);    //ܹһ
//        USB30_Send_ERDY(ENDP_3 | OUT, 1); //֪ͨ·һ
//    }
//    else if(nump == 2)
//    {
//        USB30_OUT_ClearIT(ENDP_3);
//        USB30_OUT_Set(ENDP_3, ACK, 2);    //ܹһ
//        USB30_Send_ERDY(ENDP_3 | OUT, 2); //֪ͨ·һ
//    }
//    else if(nump == 3)
//    {
//        USB30_OUT_ClearIT(ENDP_3);
//        USB30_OUT_Set(ENDP_3, ACK, 3);    //ܹһ
//        USB30_Send_ERDY(ENDP_3 | OUT, 3); //֪ͨ·һ
//    }
}
/*******************************************************************************
 * @fn      EP4_OUT_Callback
 *
 * @brief   USB3.0 endpoint4 out callback.
 *
 * @return   None
 */
void EP4_OUT_Callback(void)
{
//    UINT16 rx_len, i;
//    UINT8  nump;
//    UINT8  status;
//    USB30_OUT_Status(ENDP_4, &nump, &rx_len, &status); //ȡյİ
//    if(nump == 0)
//    {
//        USB30_OUT_ClearIT(ENDP_4);                                         //˵״̬ 
//        USBSS->UEP4_RX_DMA = (UINT32)(UINT8 *)endp4RTbuff;                 //ͻģʽڵַԶƫ ַ
//        USB30_IN_Set(ENDP_4, ENABLE, ACK, DEF_ENDP4_IN_BURST_LEVEL, 1024); //ܹ4
//        USB30_Send_ERDY(ENDP_4 | IN, DEF_ENDP4_IN_BURST_LEVEL);
//    }
//    else if(nump == 1)
//    {
//        USB30_OUT_ClearIT(ENDP_4);
//        USB30_OUT_Set(ENDP_4, ACK, 1);    //ܹһ
//        USB30_Send_ERDY(ENDP_4 | OUT, 1); //֪ͨ·һ
//    }
//    else if(nump == 2)
//    {
//        USB30_OUT_ClearIT(ENDP_4);
//        USB30_OUT_Set(ENDP_4, ACK, 2);    //ܹ2
//        USB30_Send_ERDY(ENDP_4 | OUT, 2); //֪ͨ·2
//    }
//    else if(nump == 3)
//    {
//        USB30_OUT_ClearIT(ENDP_4);
//        USB30_OUT_Set(ENDP_4, ACK, 3);    //ܹ3
//        USB30_Send_ERDY(ENDP_4 | OUT, 3); //֪ͨ·3
//    }
}
/*******************************************************************************
 * @fn      EP5_OUT_Callback
 *
 * @brief   USB3.0 endpoint5 out callback.
 *
 * @return   None
 */
void EP5_OUT_Callback(void)
{
//    UINT16 rx_len, i;
//    UINT8  nump;
//    UINT8  status;
//    USB30_OUT_Status(ENDP_5, &nump, &rx_len, &status); //ȡյİ
//    if(nump == 0)
//    {
//        USB30_OUT_ClearIT(ENDP_5);                                         //˵״̬ 
//        USBSS->UEP5_RX_DMA = (UINT32)(UINT8 *)endp5RTbuff;                 //ͻģʽڵַԶƫ ַ
//        USB30_IN_Set(ENDP_5, ENABLE, ACK, DEF_ENDP5_IN_BURST_LEVEL, 1024); //ܹ4
//        USB30_Send_ERDY(ENDP_5 | IN, DEF_ENDP5_IN_BURST_LEVEL);
//    }
//    else if(nump == 1)
//    {
//        USB30_OUT_ClearIT(ENDP_5);
//        USB30_OUT_Set(ENDP_5, ACK, 1);    //ܹһ
//        USB30_Send_ERDY(ENDP_5 | OUT, 1); //֪ͨ·һ
//    }
//    else if(nump == 2)
//    {
//        USB30_OUT_ClearIT(ENDP_5);
//        USB30_OUT_Set(ENDP_5, ACK, 2);    //ܹһ
//        USB30_Send_ERDY(ENDP_5 | OUT, 2); //֪ͨ·һ
//    }
//    else if(nump == 3)
//    {
//        USB30_OUT_ClearIT(ENDP_5);
//        USB30_OUT_Set(ENDP_5, ACK, 3);    //ܹһ
//        USB30_Send_ERDY(ENDP_5 | OUT, 3); //֪ͨ·һ
//    }
}
/*******************************************************************************
 * @fn      EP6_OUT_Callback
 *
 * @brief   USB3.0 endpoint6 out callback.
 *
 * @return   None
 */
void EP6_OUT_Callback(void)
{
//    UINT16 rx_len, i;
//    UINT8  nump;
//    UINT8  status;
//    USB30_OUT_Status(ENDP_6, &nump, &rx_len, &status); //ȡյİ
//    if(nump == 0)
//    {
//        USB30_OUT_ClearIT(ENDP_6);                                         //˵״̬ 
//        USBSS->UEP6_RX_DMA = (UINT32)(UINT8 *)endp6RTbuff;                 //ͻģʽڵַԶƫ ַ
//        USB30_IN_Set(ENDP_6, ENABLE, ACK, DEF_ENDP6_IN_BURST_LEVEL, 1024); //ܹ4
//        USB30_Send_ERDY(ENDP_6 | IN, DEF_ENDP6_IN_BURST_LEVEL);
//    }
//    else if(nump == 1)
//    {
//        USB30_OUT_ClearIT(ENDP_6);
//        USB30_OUT_Set(ENDP_6, ACK, 1);    //ܹһ
//        USB30_Send_ERDY(ENDP_6 | OUT, 1); //֪ͨ·һ
//    }
//    else if(nump == 2)
//    {
//        USB30_OUT_ClearIT(ENDP_6);
//        USB30_OUT_Set(ENDP_6, ACK, 2);    //ܹ2
//        USB30_Send_ERDY(ENDP_6 | OUT, 2); //֪ͨ·2
//    }
//    else if(nump == 3)
//    {
//        USB30_OUT_ClearIT(ENDP_6);
//        USB30_OUT_Set(ENDP_6, ACK, 3);    //ܹ3
//        USB30_Send_ERDY(ENDP_6 | OUT, 3); //֪ͨ·3
//    }
}
/*******************************************************************************
 * @fn      EP7_OUT_Callback
 *
 * @brief   USB3.0 endpoint7 out callback.
 *
 * @return   None
 */
void EP7_OUT_Callback(void)
{
//    UINT16 rx_len, i;
//    UINT8  nump;
//    UINT8  status;
//    USB30_OUT_Status(ENDP_7, &nump, &rx_len, &status); //ȡյİ
//    if(nump == 0)
//    {
//        USB30_OUT_ClearIT(ENDP_7);                                         //˵״̬ 
//        USBSS->UEP7_RX_DMA = (UINT32)(UINT8 *)endp7RTbuff;                 //ͻģʽڵַԶƫ ַ
//        USB30_IN_Set(ENDP_7, ENABLE, ACK, DEF_ENDP7_IN_BURST_LEVEL, 1024); //ܹ4
//        USB30_Send_ERDY(ENDP_7 | IN, DEF_ENDP7_IN_BURST_LEVEL);
//    }
//    else if(nump == 1)
//    {
//        USB30_OUT_ClearIT(ENDP_7);
//        USB30_OUT_Set(ENDP_7, ACK, 1);    //ܹһ
//        USB30_Send_ERDY(ENDP_7 | OUT, 1); //֪ͨ·һ
//    }
//    else if(nump == 2)
//    {
//        USB30_OUT_ClearIT(ENDP_7);
//        USB30_OUT_Set(ENDP_7, ACK, 2);    //ܹ2
//        USB30_Send_ERDY(ENDP_7 | OUT, 2); //֪ͨ·2
//    }
//    else if(nump == 3)
//    {
//        USB30_OUT_ClearIT(ENDP_7);
//        USB30_OUT_Set(ENDP_7, ACK, 3);    //ܹ3
//        USB30_Send_ERDY(ENDP_7 | OUT, 3); //֪ͨ·3
//    }
}





