/*
 * YUV_DESCR.h
 *
 *  Created on: Aug 26, 2021
 *      Author: OWNER
 */

#ifndef USER_USB30_YUV_DESCR_H_
#define USER_USB30_YUV_DESCR_H_

const UINT8 YUV_config[]=
{
     0x09,      /*length*/
     0x02,      /*config descriptor type*/
     0xd6,      /*total config descriptor type*/
     0x01,
     0x03,      /*interface number*/
     0x01,      /*config value*/
     0x00,
     0x80,      /*attributes*/
     0x0c,      /*max power*/

     /* Interface Association Descriptor */
     0x08,      /*length*/
     0x0b,
     0x00,
     0x02,
     0x0e,
     0x03,
     0x00,
     0x03,
     /* Standard VC Interface Descriptor */
     0x09,
     0x04,
     0x00,
     0x00,
     0x00,
     0x0e,
     0x01,
     0x00,
     0x03,
     /* Class-specific VC Interface Descriptor */
     0x0d,
     0x24,
     0x01,
     0x10,
     0x01,
     0x4f,
     0x00,
     0xd0,
     0x97,
     0xe2,
     0x00,
     0x01,
     0x01,
     /* Input Terminal Descriptor (Composite) */
     0x12,
     0x24,
     0x02,
     0x01,
     0x01,
     0x02,
     0x00,
     0x00,
     0x00,
     0x00,
     0xff,
     0x7f,
     0x00,
     0x00,
     0x03,
     0x00,
     0x00,
     0x00,
     /* Processing Unit Descriptor */
     0x0d,
     0x24,
     0x05,
     0x02,
     0x01,
     0x00,
     0x00,
     0x03,
     0x0f,
     0x08,
     0x00,
     0x00,
     0x00,
     /* Extension Unit Descriptor */
     0x1a,
     0x24,
     0x06,
     0x04,
     0xb8,
     0xdc,
     0xa6,
     0x25,
     0x04,
     0x4c,
     0xf8,
     0xa0,
     0xa2,
     0xa7,
     0x7b,
     0x92,
     0x32,
     0xa4,
     0x9b,
     0x1e,
     0x01,
     0x01,
     0x02,
     0x01,
     0x01,
     0x00,
     /* Output Terminal Descriptor */
     0x09,
     0x24,
     0x03,
     0x03,
     0x01,
     0x01,
     0x00,
     0x04,
     0x00,
     /* Standard VS Interface Descriptor */
     0x09,
     0x04,
     0x01,
     0x00,
     0x01,
     0x0e,
     0x02,
     0x00,
     0x03,
     /* VS Interface Input Header Descriptor */
     0x0e,
     0x24,
     0x01,
     0x01,
     0x1f,
     0x01,
     0x81,
     0x00,
     0x03,
     0x00,
     0x00,
     0x00,
     0x01,
     0x00,
     /* Class-specific VS Format Descriptor----VS_FORMAT_UNCOMPRESSED */
     0x1b,       /* bLength */
     0x24,       /* bDescriptorTypeCS_INTERFACE */
     0x04,       /* bDescriptorSubtype VS_FORMAT_UNCOMPRESSED */
     0x01,       /* bFormatIndexFirst (and only) format descriptor  */
     0x08,       /* bNumFrameDescriptors8 frame descriptor for this format follows */
     0x59,
     0x55,
     0x59,
     0x32,
     0x00,
     0x00,
     0x10,
     0x00,
     0x80,
     0x00,
     0x00,
     0xaa,
     0x00,
     0x38,
     0x9b,
     0x71,
     0x10,
     0x01,
     0x00,
     0x00,
     0x00,
     0x00,
     /* Class-specific VS Frame Descriptor----VS_FRAME_UNCOMPRESSED */
         /* 1920*1080@60fps */
     0x1e,
     0x24,
     0x05,
     0x01,
     0x00,
     0x80, 0x07,                /* Width of frame1920 */
     0x38, 0x04,                /* Height of frame1080*/
     0x10, 0x00, 0x00, 0x00,    /* Min bit rate in bits/s */
     0x00, 0x84, 0xd7, 0x17,    /* Max bit rate in bits/s */
     0x00, 0x48, 0x3f, 0x00,    /* Maximum video or still frame size, in bytes1920*1080*2  */
     0x0a, 0x8b, 0x02, 0x00,    /* bFrameIntervalType: Continuous frame interval 60*/
     0x01,                      /* Default frame interval is 30fps(333333ns) */
     0x0a, 0x8b, 0x02, 0x00,    /* 60fps(166666ns) */



     /*1280*720@60fps */
     0x1e,
     0x24,
     0x05,
     0x02,
     0x00,
     0x00, 0x05,                /* Width of frame1280 */
     0xd0, 0x02,                 /* Height of frame720*/
     0x10, 0x00,  0x00, 0x00,    /* Min bit rate in bits/s  16*/
     0x00, 0x84,  0xd7, 0x17,   /* Max bit rate in bits/s   47M*/
     0x00, 0x20,  0x1c, 0x00,   /* Maximum video or still frame size, in bytes1280*720*2  */
     0x0a, 0x8b,  0x02, 0x00,    /* bFrameIntervalType: Continuous frame interval 60*/
     0x01,                       /* Default frame interval is 30fps(333333ns) */
     0x0a,  0x8b, 0x02, 0x00,    /* 60fps(166666ns) */

     /*1440*900@60fps */
     0x1e,
     0x24,
     0x05,
     0x03,
     0x00,
     0xa0, 0x05,                  /* Width of frame1440 */
     0x84, 0x03,                  /* Height of frame900*/
     0x10, 0x00, 0x00, 0x00,      /* Min bit rate in bits/s  16*/
     0x00, 0x84, 0xd7, 0x17,      /* Max bit rate in bits/s   47M*/
     0x00, 0x8d, 0x27, 0x00,      /* Maximum video or still frame size, in bytes1440*900*2  */
     0x0a, 0x8b, 0x02, 0x00,      /* bFrameIntervalType: Continuous frame interval 60*/
     0x01,                        /* Default frame interval is 30fps(333333ns) */
     0x0a, 0x8b, 0x02, 0x00,      /* 60fps(166666ns) */



     /*1336*768@60fps */
     0x1e,
     0x24,
     0x05,
     0x04,
     0x00,
     0x56, 0x05,                        /* Width of frame1336 */
     0x00, 0x03,                        /* Height of frame768*/
     0x10, 0x00, 0x00, 0x00,            /* Min bit rate in bits/s  16*/
     0x00, 0x84, 0xd7, 0x17,            /* Max bit rate in bits/s   47M*/
     0x00, 0x04, 0x20, 0x00,            /* Maximum video or still frame size, in bytes1336*768*2  */
     0x0a, 0x8b, 0x02, 0x00,            /* bFrameIntervalType: Continuous frame interval 60*/
     0x01,                              /* Default frame interval is 30fps(333333ns) */
     0x0a, 0x8b, 0x02, 0x00,            /* 60fps(166666ns) */


     /*1600*1200@60fps */
     0x1e,
     0x24,
     0x05,
     0x05,
     0x00,
     0x40, 0x06,                       /* Width of frame1600 */
     0xb0, 0x04,                       /* Height of frame1200*/
     0x10, 0x00, 0x00, 0x00,           /* Min bit rate in bits/s  16*/
     0x00, 0x84, 0xd7, 0x17,           /* Max bit rate in bits/s   47M*/
     0x00, 0x98, 0x3a, 0x00,           /* Maximum video or still frame size, in bytes1600*1200*2  */
     0x0a, 0x8b, 0x02, 0x00,           /* bFrameIntervalType: Continuous frame interval 60*/
     0x01,                             /* Default frame interval is 30fps(333333ns) */
     0x0a, 0x8b, 0x02, 0x00,           /* 60fps(166666ns) */

     /*1024*768@60fps */
     0x1e,
     0x24,
     0x05,
     0x06,
     0x00,
     0x00, 0x04,                      /* Width of frame1024 */
     0x00, 0x03,                      /* Height of frame768*/
     0x10, 0x00, 0x00, 0x00,          /* Min bit rate in bits/s  16*/
     0x00, 0x84, 0xd7, 0x17,          /* Max bit rate in bits/s   47M*/
     0x00, 0x00, 0x18, 0x00,          /* Maximum video or still frame size, in bytes1024*768*2  */
     0x0a, 0x8b, 0x02, 0x00,          /* bFrameIntervalType: Continuous frame interval 60*/
     0x01,                            /* Default frame interval is 30fps(333333ns) */
     0x0a, 0x8b, 0x02, 0x00,          /* 60fps(166666ns) */

     /*1280*720@60fps */
     0x1e,
     0x24,
     0x05,
     0x07,
     0x00,
     0x20, 0x03,
     0x58, 0x02,
     0x10, 0x00, 0x00, 0x00,
     0x00, 0x84, 0xd7, 0x17,
     0x00, 0xa6, 0x0e, 0x00,
     0x0a, 0x8b, 0x02, 0x00,
     0x01,
     0x0a, 0x8b, 0x02, 0x00,

     /* Class-specific VS Frame Descriptor----VS_FRAME_UNCOMPRESSED */
     /*1280*720@60fps */
     0x1e,
     0x24,
     0x05,
     0x08,
     0x00,
     0x80, 0x02,
     0xe0, 0x01,
     0x10, 0x00, 0x00, 0x00,
     0x00, 0x84, 0xd7, 0x17,
     0x00, 0x60, 0x09, 0x00,
     0x0a, 0x8b, 0x02, 0x00,
     0x01,
     0x0a, 0x8b, 0x02, 0x00,

     0x06, 0x02, 0x0d, 0x00, 0x00, 0x00,

     0x07, 0x05, 0x81, 0x02, 0x00, 0x04, 0x00,
     0x06, 0x30, 0x0f, 0x00, 0x00, 0x00,
     0x08, 0x0b, 0x02, 0x01, 0xff, 0x06, 0x02, 0x02,
     0x09, 0x04, 0x02, 0x00, 0x03, 0xff, 0x06, 0x02, 0x02,
     0x07, 0x05, 0x05, 0x02, 0x00, 0x04, 0x00, 0x06, 0x30, 0x0f, 0x00, 0x00, 0x00,
     0x07, 0x05, 0x85, 0x02, 0x00, 0x04, 0x00, 0x06, 0x30, 0x0f, 0x00, 0x00, 0x00,
     0x07, 0x05, 0x86, 0x03, 0x04, 0x00, 0x09, 0x06, 0x30, 0x00, 0x00, 0x01, 0x00,

};

//09 02 5c 01 04 01 00 a0 4b
//08 0b 00 02 0e 03 00 08
//09 04 00 00 00 0e 01 00 08
//0d 24 01 00 01 4d 00 00 0e 27 07 01 01
//12 24 02 01 01 02 00 00 00 00 00 00 00 00 03 00 00 00
//0b 24 05 03 01 00 00 02 00 00 00 09 24 03 02 01 01 00 04 00
//1a 24 06 04 5b 12 6d c6 80 04 44 08 8c 26 b8 36 3a 84 de 63 03 01 03  01 07 00
//09 04 01 00 00 0e 02 00 08 0e 24 01 01 51 00 89 00 02 00 00 00 01 00
//1b 24 04 01 01 59 55 59 32 00 00 10 00 80 00 00 aa 00 38 9b 71 10 01 00 00 00 00
//
//22
//24
//05
//01
//00
//80 07
//38 04
//00 00 a7 76
//00 00 a7 76
//00 48 3f 00
//0a 8b 02 00
//02
//0a 8b 02 00
//15 16 05 00
//
//
//
//06 24 0d 01 01 04
//
//
//09 04 01  01 01 0e 02  00 08 07 05  89 05 00 04  01 06 30 0b  02 00 90 09  04 01 02 01  0e 02 00 08
//07 05 89 05  00 04 01 06  30 0e 00 00  3c 08 0b 02  02 01 02 00  09 09 04 02  00 00 01 01  00 09 09 24
//01 00 01 26  00 01 03 0c  24 02 01 01  02 00 01 00  00 00 00 09  24 03 02 01  01 00 03 00  08 24 06 03
//01 01 03 00  09 04 03 00  00 01 02 00  09 09 04 03  01 01 01 02  00 09 07 24  01 02 01 01  00 0b 24 02
//01 02 02 10  01 80 bb 00  07 05 8a 05  c0 00 04 06  30 00 00 c0  00 07 25 01  01 00 00 00


#endif /* USER_USB30_YUV_DESCR_H_ */
