/******************** (C) COPYRIGHT 2011 WCH ***********************************
* File Name          : HAL.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/07/10
* Description        : Ӳزֳ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "MAIN.h"															/* ͷļ */

/******************************************************************************/
/*  */

/*******************************************************************************
* Function Name  : Delay_uS
* Description    : ΢뼶ʱ
* Input          : delay---ʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void Delay_uS( UINT16 delay )
{
	UINT16 i, j;

	for( i = delay; i != 0; i -- ) 
	{
		for( j = 6; j != 0; j -- )
		{
			asm volatile ("nop");
			asm volatile ("nop");
			asm volatile ("nop");
			asm volatile ("nop");
			asm volatile ("nop");
		}
	}
}

/*******************************************************************************
* Function Name  : Delay_mS
* Description    : 뼶ʱ
* Input          : delay---ʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void Delay_mS( UINT16 delay )
{
	UINT16 i, j;

	for( i = delay; i != 0; i -- ) 
	{
		for( j = 200; j != 0; j -- )
		{
			Delay_uS( 5 );
		}		
	}
}

/*******************************************************************************
* Function Name  : UART1_Init
* Description    : 1ʼ
* Input          : baudrate:ڲ
* Output         : None
* Return         : None
*******************************************************************************/
void UART1_Init( UINT32 baudrate )
{
    UINT32 x;
    UINT32 t = FREQ_SYS;

    x = 10 * t * 2 / 16 / baudrate;
    x = ( x + 5 ) / 10;
    R8_UART1_DIV = 1;
    R16_UART1_DL = x;
    R8_UART1_FCR = RB_FCR_FIFO_TRIG | RB_FCR_TX_FIFO_CLR | RB_FCR_RX_FIFO_CLR | RB_FCR_FIFO_EN;
    R8_UART1_LCR = RB_LCR_WORD_SZ;
    R8_UART1_IER = RB_IER_TXD_EN;
    R32_PA_SMT |= ( 1 << 8 ) | ( 1 << 7 );
    R32_PA_DIR |= ( 1 << 8 );
}
/*******************************************************************************
* Function Name  : Timer1_Init
* Description    : ʱ1ʼ(ʱ2mS)
* Input          : time: ʱʱ
* Output         : None
* Return         : None
*******************************************************************************/
void Timer1_Init( UINT32 time )
{
    R32_TMR1_CNT_END = time;
    R8_TMR1_CTRL_MOD = RB_TMR_ALL_CLEAR;
    R8_TMR1_CTRL_MOD = RB_TMR_COUNT_EN | RB_TMR_CAP_COUNT;
    R8_TMR1_INTER_EN |= RB_TMR_IE_CYC_END;

    PFIC_EnableIRQ( TMR1_IRQn );
}
/*******************************************************************************
* Function Name  : TMR1_IRQHandler
* Description    : Interruption function
* Input          : None
* Return         : None
*******************************************************************************/
void TMR1_IRQHandler (void) __attribute__((interrupt("WCH-Interrupt-fast")));
void TMR1_IRQHandler( void )
{
    if( R8_TMR1_INT_FLAG & RB_TMR_IE_CYC_END )
    {
        /* жϱ־ */
        R8_TMR1_INT_FLAG = RB_TMR_IE_CYC_END;

        /* ˵1´мʱ */
        Endp1_Down_IdleCount++;

        /* ӡмʱ */
#if( DEF_FUN_DEBUG_EN == 0x01 )
        Dbg_Idle_TimeCount++;
        if( Dbg_Idle_TimeCount >= 15 * 1000 )
        {
            Dbg_Idle_TimeCount = 0;

            /* δHSPIͻղܽдӡ */
            printf("~~~~~~~~~~~~~~~~~~~~~~1\n");
            printf("Dbg_USB_Down_TLen: %x%x\n",(UINT32)( Dbg_USB_Down_TLen >> 32 ), (UINT32)( Dbg_USB_Down_TLen ) );
            printf("Dbg_HSPI_Tx_TLen:  %x%x\n",(UINT32)( Dbg_HSPI_Tx_TLen >> 32 ), (UINT32)( Dbg_HSPI_Tx_TLen ) );
            printf("Dbg_HSPI_Rx_TLen:  %x%x\n",(UINT32)( Dbg_HSPI_Rx_TLen >> 32 ), (UINT32)( Dbg_HSPI_Rx_TLen ) );
            printf("Dbg_USB_Up_TLen:   %x%x\n",(UINT32)( Dbg_USB_Up_TLen >> 32 ), (UINT32)( Dbg_USB_Up_TLen ) );
            printf("HSPI_Tx_Data_Len:  %x\n",(UINT32)HSPI_Tx_Data_RemainLen);
            printf("HSPI_Rx_Data_Len:  %x\n",(UINT32)HSPI_Rx_Data_RemainLen);
            printf("Endp1_Up_Status:   %x\n",(UINT32)Endp1_Up_Status);

            printf("~~~~~~~~~~~~~~~~~~~~~~2\n");
            printf("Dbg_USB_Down_TLen: %d\n",(UINT32)Dbg_USB_Down_TLen);
            printf("Dbg_HSPI_Tx_TLen:  %d\n",(UINT32)Dbg_HSPI_Tx_TLen);
            printf("Dbg_HSPI_Rx_TLen:  %d\n",(UINT32)Dbg_HSPI_Rx_TLen);
            printf("Dbg_USB_Up_TLen:   %d\n",(UINT32)Dbg_USB_Up_TLen);
            printf("HSPI_Tx_Data_Len:  %d\n",(UINT64)HSPI_Tx_Data_RemainLen);
            printf("HSPI_Rx_Data_Len:  %d\n",(UINT64)HSPI_Rx_Data_RemainLen);
            printf("Endp1_Up_Status:   %d\n",(UINT64)Endp1_Up_Status);
        }
#endif
    }
}

/*******************************************************************************
* Function Name  : GPIO_Init
* Description    : ӲGPIOʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void GPIO_Init( void )
{
    UINT32 temp1;

    /* ACT(PB24)HRTS(PB23)Ϊ,Ϊ16mA */
    PIN_HRTS_HIGH( );
    R32_PB_DIR |= ( ( 1 << 23 ) | ( 1 << 24 ) );
    R32_PB_DRV |= ( ( 1 << 23 ) | ( 1 << 24 ) );
    R32_PB_PU &= ~( ( 1 << 23 ) | ( 1 << 24 ) );
    R32_PB_PD &= ~( ( 1 << 23 ) | ( 1 << 24 ) );

    /* HCTS(PB22)Ϊ */
    R32_PB_DIR &= ~( ( 1 << 22 ) );
    R32_PB_PU |= ( ( 1 << 22 ) );
    R32_PB_PD &= ~( ( 1 << 22 ) );

    /* MODE(PA12)Ϊ */
    R32_PA_DIR &= ~( ( 1 << 12 ) );
    R32_PA_PU |= ( ( 1 << 12 ) );
    R32_PA_PD &= ~( ( 1 << 12 ) );

    /* MODE(PA12)Ϊ,Ϊ16mA */
    R32_PA_DIR |= ( ( 1 << 12 ) );
    R32_PA_DRV |= ( ( 1 << 12 ) );
    R32_PA_PU &= ~( ( 1 << 12 ) );
    R32_PA_PD &= ~( ( 1 << 12 ) );
}
