/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.c
* Author             : WCH
* Version            : V1.1
* Date               : 2020/12/23
* Description 		 : 
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/
#include "MAIN.h"
//#include "CH56x_common.h"
//#include "CH56x_usb30_lib.h"
//#include "CH56x_usb30.h"
//#include "CH56x_usb20.h"
/* Global define */
//#define  FREQ_SYS       120000000
#define  UART1_BAUD     921600
/* Global Variable */
UINT32V Dbg_Idle_TimeCount = 0x00;
UINT64V Dbg_HSPI_Tx_TLen = 0x00;
UINT64V Dbg_HSPI_Rx_TLen = 0x00;
UINT64V Dbg_USB_Up_TLen = 0x00;
UINT64V Dbg_USB_Down_TLen = 0x00;
/* Function declaration */

/*******************************************************************************
 * @fn        DebugInit
 *
 * @brief     Initializes the UART1 peripheral.
 *
 * @param     baudrate: UART1 communication baud rate.
 *
 * @return    None
 */
void DebugInit(UINT32 baudrate)
{
	UINT32 x;
	UINT32 t = FREQ_SYS;
	x = 10 * t * 2 / 16 / baudrate;
	x = ( x + 5 ) / 10;
	R8_UART1_DIV = 1;
	R16_UART1_DL = x;
	R8_UART1_FCR = RB_FCR_FIFO_TRIG | RB_FCR_TX_FIFO_CLR | RB_FCR_RX_FIFO_CLR | RB_FCR_FIFO_EN;
	R8_UART1_LCR = RB_LCR_WORD_SZ;
	R8_UART1_IER = RB_IER_TXD_EN;
	R32_PA_SMT |= (1<<8) |(1<<7);
	R32_PA_DIR |= (1<<8);
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main()
{
    UINT32  addr,i,j;
    UINT32V remanlen;
    UINT32V len;
    UINT32V packnum;
    UINT32V packlen;
    UINT32V offset;
    UINT32V org_addr;

    SystemInit(FREQ_SYS);
	Delay_Init(FREQ_SYS);

/* ôڵ */
	DebugInit(UART1_BAUD);
	PRINT("CH56x USB3.0 & USB2.0 device test(120MHz) !\n");

    HSPI_GPIO_Init( );                                                          /* HSPIӿGPIOʼ */
    GPIO_Init( );

//USBʼ
    R32_USB_CONTROL = 0;
    PFIC_SetPriority( USBSS_IRQn, 0x80 );
    PFIC_SetPriority( LINK_IRQn, 0x80 );

    PFIC_EnableIRQ(USBSS_IRQn);
    PFIC_EnableIRQ(LINK_IRQn);
    PFIC_EnableIRQ(TMR0_IRQn);
    R8_TMR0_INTER_EN = RB_TMR_IE_CYC_END;
    TMR0_TimerInit( 67000000 );   //Լ0.5

	USB30D_init(ENABLE);          //USB3.0ʼ ʼ֮ǰȷUSB3.0жʹ
	PFIC_SetFastIRQ( (UINT32)USBSS_IRQHandler ,USBSS_IRQn, 0);
/*****************************HSPI豸سʼ **************************/
    HSPI_Init( );                                                               /* HSPIӿڳʼ */

/*****************************ʱسʼ **************************/
    Timer1_Init( 240000 );                                                      /* ʱ1ʼ(ʱ2mS) */
/*******************************************************************/
    HSPI_Rx_Notice_Status = 0x01;

    HSPI_Rx_Data_RemainLen = 0x00;

	while(1){
	    printf("m\n");
	    mDelaymS(1000);
	}
}

